SystemOrganization addCategory: #ConfigurationOfArtefact!

Object subclass: #ConfigurationOfArtefact
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfArtefact'!

!ConfigurationOfArtefact commentStamp: '<historical>' prior: 0!
A ConfigurationOfArtefact is the configuration for Artefact.

Instance Variables
	project:		<Object>

project
	- xxxxx
!

!ConfigurationOfArtefact class methodsFor: 'development support' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfArtefact class methodsFor: 'private' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfArtefact class methodsFor: 'private' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfArtefact class methodsFor: 'private' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfArtefact class methodsFor: 'metacello tool support' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfArtefact class methodsFor: 'loading' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfArtefact class methodsFor: 'loading' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfArtefact class methodsFor: 'loading' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfArtefact class methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
project

	^self new project! !

!ConfigurationOfArtefact class methodsFor: 'development support' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfArtefact methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 18:59'!
baseline09: spec
	<version: '0.9-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://www.squeaksource.com/Units'.
			spec
				package: 'Units' with: 'Units-espin.36'.
			spec repository: 'http://smalltalkhub.com/mc/RMoD/Artefact/main'.
			spec
				package: 'Artefact']! !

!ConfigurationOfArtefact methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/17/2013 15:05'!
baseline10: spec
	<version: '1.0-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://smalltalkhub.com/mc/MarcusDenker/Units/main'.
			spec
				package: 'Units' with: 'Units-espin.36'.
			spec repository: 'http://smalltalkhub.com/mc/RMoD/Artefact/main'.
			spec
				package: 'Artefact']! !

!ConfigurationOfArtefact methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfArtefact methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 18:54'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfArtefact methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/17/2013 15:10'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfArtefact methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 19:02'!
version09: spec
	<version: '0.9' imports: #('0.9-baseline')>
	
	spec for: #common do: [
		spec
			blessing: #stable;
			author: 'Olivier Auverlot and Guillaume Larcheveque';
			description: 'configuration for artefact'.
		spec
			package: 'Artefact' with: 'Artefact-GuillaumeLarcheveque.194'.
	]! !

!ConfigurationOfArtefact methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 20:04'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec
			blessing: #stable;
			author: 'Olivier Auverlot and Guillaume Larcheveque';
			description: 'configuration for artefact'.
		spec
			package: 'Artefact' with: 'Artefact-GuillaumeLarcheveque.228'.
	]! !
